package com.jsowell.common.core.controller;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.jsowell.common.constant.HttpStatus;
import com.jsowell.common.core.domain.AjaxResult;
import com.jsowell.common.core.domain.model.LoginUser;
import com.jsowell.common.core.domain.vo.AuthorizedDeptVO;
import com.jsowell.common.core.page.PageDomain;
import com.jsowell.common.core.page.PageResponse;
import com.jsowell.common.core.page.TableDataInfo;
import com.jsowell.common.core.page.TableSupport;
import com.jsowell.common.enums.ykc.ReturnCodeEnum;
import com.jsowell.common.exception.BusinessException;
import com.jsowell.common.util.DateUtils;
import com.jsowell.common.util.JWTUtils;
import com.jsowell.common.util.PageUtils;
import com.jsowell.common.util.SecurityUtils;
import com.jsowell.common.util.StringUtils;
import com.jsowell.common.util.sql.SqlUtil;
import org.apache.commons.collections4.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.WebDataBinder;
import org.springframework.web.bind.annotation.InitBinder;

import javax.servlet.http.HttpServletRequest;
import java.beans.PropertyEditorSupport;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * web层通用数据处理
 *
 * @author jsowell
 */
public class BaseController {
	protected final Logger logger = LoggerFactory.getLogger(this.getClass());

	/**
	 * 将前台传递过来的日期格式的字符串，自动转化为Date类型
	 */
	@InitBinder
	public void initBinder(WebDataBinder binder) {
		// Date 类型转换
		binder.registerCustomEditor(Date.class, new PropertyEditorSupport() {
			@Override
			public void setAsText(String text) {
				setValue(DateUtils.parseDate(text));
			}
		});
	}

	/**
	 * 设置请求分页数据
	 */
	protected void startPage() {
		PageUtils.startPage();
	}

	/**
	 * 设置请求排序数据
	 */
	protected void startOrderBy() {
		PageDomain pageDomain = TableSupport.buildPageRequest();
		if (StringUtils.isNotEmpty(pageDomain.getOrderBy())) {
			String orderBy = SqlUtil.escapeOrderBySql(pageDomain.getOrderBy());
			PageHelper.orderBy(orderBy);
		}
	}

	/**
	 * 清理分页的线程变量
	 */
	protected void clearPage() {
		PageUtils.clearPage();
	}

	/**
	 * 响应请求分页数据
	 */
	@SuppressWarnings({"rawtypes", "unchecked"})
	protected TableDataInfo getDataTable(List<?> list) {
		TableDataInfo rspData = new TableDataInfo();
		rspData.setCode(HttpStatus.SUCCESS);
		rspData.setMsg("查询成功");
		rspData.setRows(list);
		rspData.setTotal(new PageInfo(list).getTotal());
		return rspData;
	}

	protected TableDataInfo getDataTable(PageResponse pageResponse) {
		TableDataInfo rspData = new TableDataInfo();
		rspData.setCode(HttpStatus.SUCCESS);
		rspData.setMsg("查询成功");
		rspData.setRows(pageResponse.getList());
		rspData.setTotal(pageResponse.getTotal());
		return rspData;
	}

	/**
	 * 返回成功
	 */
	public AjaxResult success() {
		return AjaxResult.success();
	}

	/**
	 * 返回失败消息
	 */
	public AjaxResult error() {
		return AjaxResult.error();
	}

	/**
	 * 返回成功消息
	 */
	public AjaxResult success(String message) {
		return AjaxResult.success(message);
	}

	/**
	 * 返回失败消息
	 */
	public AjaxResult error(String message) {
		return AjaxResult.error(message);
	}

	/**
	 * 响应返回结果
	 *
	 * @param rows 影响行数
	 * @return 操作结果
	 */
	protected AjaxResult toAjax(int rows) {
		return rows > 0 ? AjaxResult.success() : AjaxResult.error();
	}

	/**
	 * 响应返回结果
	 *
	 * @param result 结果
	 * @return 操作结果
	 */
	protected AjaxResult toAjax(boolean result) {
		return result ? success() : error();
	}

	/**
	 * 页面跳转
	 */
	public String redirect(String url) {
		return StringUtils.format("redirect:{}", url);
	}

	/**
	 * 获取用户缓存信息
	 */
	public LoginUser getLoginUser() {
		return SecurityUtils.getLoginUser();
	}

	/**
	 * 获取登录用户id
	 */
	public Long getUserId() {
		return getLoginUser().getUserId();
	}

	/**
	 * 获取登录部门id
	 */
	public Long getDeptId() {
		return getLoginUser().getDeptId();
	}

	/**
	 * 获取登录用户名
	 */
	public String getUsername() {
		return getLoginUser().getUsername();
	}

	public String getMemberIdByAuthorization(String authorization) {
		if (StringUtils.isBlank(authorization)) {
			throw new BusinessException(ReturnCodeEnum.CODE_TOKEN_ERROR);
		}
		String memberId = JWTUtils.getMemberId(authorization);
		if (StringUtils.isBlank(memberId)) {
			throw new BusinessException(ReturnCodeEnum.CODE_TOKEN_ERROR);
		}
		// logger.info("authorization:{}, memberId:{}", authorization, memberId);
		return memberId;
	}

	public String getMemberIdByAuthorization(HttpServletRequest request) {
		return getMemberIdByAuthorization(request.getHeader("Authorization"));
	}

	/**
	 * 获取当前登录账号有权限的运营商部门id
	 *
	 * 平台管理员账号会返回空数组
	 * @return
	 */
	public List<String> getDeptIds() {
		// 获取登录账号信息
		AuthorizedDeptVO authorizedMap = SecurityUtils.getAuthorizedMap();
		if (authorizedMap == null) {
			return new ArrayList<>();
		}
		List<String> merchantDeptIds = authorizedMap.getMerchantDeptIds();
		if (CollectionUtils.isNotEmpty(merchantDeptIds)) {
			return merchantDeptIds;
		}
		return new ArrayList<>();
	}
}
